IncludeScript("murdermystery/roles/Sheriffs.nut")
artifact_check_radius 	<- 110
Map_SpawnPoints 		<- []
ValidArtifactSpawns 	<- []
artifact_models 		<- ["models/buildables/gibs/sapper_gib002.mdl", "models/buildables/gibs/sd_sapper_gib002.mdl", 	"models/buildables/gibs/sentry1_gib1.mdl", "models/buildables/gibs/sentry2_gib1.mdl",  "models/buildables/gibs/sapper_gib001.mdl", 	"models/buildables/gibs/teleporter_gib2.mdl"]
artifact_size 			<- [1.15, 										1.15, 											1, 											1, 											1.5 										1.2]
artifact_color 			<- ["130 255 113", 								"130 255 113", 									"0 255 100", 								"0 255 100", 								"130 255 113", 								"0 255 100"]
artifact_skin 			<- [0, 											0, 												1, 											1, 											0, 											1]

::FindSpawns <- function () {
	Map_SpawnPoints.clear()
	local spawnpoints = null
	while(spawnpoints = Entities.FindByClassname(spawnpoints, "info_player_teamspawn")){
		Map_SpawnPoints.append(spawnpoints)
	}
}
::UpdateArtifactSpawnsList <- function () {
	if (Map_SpawnPoints.len() <= 0) {
		FindSpawns
	}
	else foreach (SpawnPoint in Map_SpawnPoints) {
		if (true) {}
	}
}

//artifact spawner
function artifact(){
	FindSpawns()
	local artifact_spawn = Map_SpawnPoints[RandomInt(0, Map_SpawnPoints.len()-1)]
	local random_prop = RandomInt(0, artifact_models.len()-1)
	local random_model 	= artifact_models[random_prop]
	local random_size 	= artifact_size[random_prop]
	local random_color 	= artifact_color[random_prop]
	local random_skin 	= artifact_skin[random_prop]
    local artifact = SpawnEntityFromTable("prop_physics_override",{
        targetname    = "artifact",
        Model         = random_model,
        solid         = 6,
        origin        = artifact_spawn.GetCenter(),
        angles        = artifact_spawn.GetAbsAngles(),
        vscripts      = "murdermystery/artifact_system.nut",
        thinkfunction = "artifactThink",
		modelscale 	  = random_size,
		rendercolor	  = random_color,
		renderfx 	  = 2,
		renderamt 	  = 210,
		rendermode 	  = 0,
		skin 		  = random_skin,
		spawnflags 	  = 4,
    	}
	)

	local light = SpawnEntityFromTable("light_dynamic", {
        _cone               = 0,
        _inner_cone         = 50,
        _light              = "0 50 0",
        angles              = "-90 0 0", //artifact.GetAbsAngles(),
        origin              = artifact.GetCenter(),//+artifact_spawn.GetAbsAngles().Forward()*10,
        brightness          = 3,
        distance            = 400,
        pitch               = -90,
        spotlight_radius    = 0,
        style               = 0,
		//spawnflags			= 2,
    }
    )
   EntFireByHandle(light, "SetParent", "!activator", 0, artifact, artifact)
}

//artifact think script
const RETHINK_TIME = 0.2
function artifactThink(){
	for (local i = 1; i <= MaxPlayers ; i++){
    	local player = PlayerInstanceFromIndex(i)
    	if (player == null) continue

		local combo = self.GetOrigin() - player.GetOrigin()
		if ((abs(combo.y) + abs(combo.x)) >= artifact_check_radius) continue

		player.ValidateScriptScope()
		if (player.GetScriptScope().MyRole == "Bystander") {
            if (player.GetScriptScope().MyPartCount <= 3) { //increases players gunpart score
                player.GetScriptScope().MyPartCount = player.GetScriptScope().MyPartCount +1
				ClientPrint(player, 3, player.GetScriptScope().MyPartCount + " out of 5 artifacts acquired!")
                self.Destroy()
                artifact()
            }
            else if (player.GetScriptScope().MyPartCount >= 4) {//gives player gun
				Marshal(player)
				self.Destroy()
                artifact()
            }
        }
		else if (player.GetScriptScope().MyRole == "Murderer") {
			player.GetScriptScope().MyPartCount = player.GetScriptScope().MyPartCount +1
			self.Destroy()
            artifact()
		}
		return
	}
	/*
    local nearbyplayer = Entities.FindByClassnameNearest("player", self.GetOrigin(), artifact_check_radius)

    if (nearbyplayer && nearbyplayer.GetTeam() == 2) { //printl("player nearby")
		nearbyplayer.ValidateScriptScope()
        if (nearbyplayer.GetScriptScope().MyRole == "Bystander") {
            if (nearbyplayer.GetScriptScope().MyPartCount <= 3) { //increases players gunpart score
                nearbyplayer.GetScriptScope().MyPartCount = nearbyplayer.GetScriptScope().MyPartCount +1
				ClientPrint(nearbyplayer, 3, nearbyplayer.GetScriptScope().MyPartCount + " out of 5 artifacts acquired!")
                self.Destroy()
                artifact()
            }
            else if (nearbyplayer.GetScriptScope().MyPartCount >= 4) {//gives player gun
				Marshal(nearbyplayer)
            }
        }
		else if (nearbyplayer.GetScriptScope().MyRole == "Murderer") {
			nearbyplayer.GetScriptScope().MyPartCount = nearbyplayer.GetScriptScope().MyPartCount +1
			self.Destroy()
            artifact()
		}
    }*/
	//kills self if round is not ongoing
	if (GetRoundState() != 4) {
		self.Destroy()
	}
    return RETHINK_TIME
}

__CollectGameEventCallbacks(this)
